const sha256 = require("sha256");

const urop = (title, season, episode) => {
    if (title === undefined) {
        return undefined;
    }
    const sumTo = (arr, to) => arr.slice(0, Math.max(0, to)).reduce((a, b) => a + b, 0);
    const canonicaLized = [ title.toLowerCase().replace(/\bthe\b|\ba\b|\W/g, ''), season, episode ].filter(x => x != null && x != undefined).join('-');
    const hash = sha256(canonicaLized);
    return [8, 4, 4, 4, 12].map((len, i, arr) => hash.substr(sumTo(arr, i), len)).join('-');
}

const season = (title) => {
    if (title === undefined || title == null) {
        return undefined;
    }
    const regexSeason = /\(S([0-9]+)/;
    const season = title.match(regexSeason);
    return season ? (season.length > 1 ? season[1] : undefined) : undefined;
}

const episode = (title) => {
    if (title === undefined || title == null) {
        return undefined;
    }
    const regexEpisode = /Ep([0-9]+)/;
    const episode = title.match(regexEpisode);
    return episode ? (episode.length > 1 ? episode[1] : undefined) : undefined;
}


module.exports = {
    urop,
    season,
    episode
};
